﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Net;
using System.Net.Sockets;
//********************ネットワークサーモグラフィ映像表示プログラム V1.0***********************
//                                                                    2009.10.16
//                                                             Neo-Tech-Lab H.GURITA
//********************************************************************************************
namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private byte[] rdata = new byte[1468];//LAN　受信データ
        private byte[] sdata = new byte[1468];//LAN　送信データ
        string IP_ADRS = "192.168.100.3";//サーモグラフィのIPアドレス
        UdpClient UDP = new UdpClient(11001);//My UDP port
        double TOFF = 0.0;//温度センサーの補正用オフセット（必要に応じて設定）
        
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int i;
            int ph, pw;
            button1.Enabled = false;
            button2.Enabled = true;
            Graphics gr = pictureBox2.CreateGraphics();
            ColorIND CIND0 = new ColorIND();
            Pen p;
            if (Convert.ToDouble(textBox1.Text) <= Convert.ToDouble(textBox2.Text))
            {
                textBox1.Text = "100";
                textBox2.Text = "0";
            }
            ph = pictureBox2.ClientSize.Height;
            pw = pictureBox2.ClientSize.Width;
            CIND0.max = ph;
            CIND0.min = 0;
            for (i = 0; i < ph; i++)
            {//カラーインデックスの表示
                CIND0.deg = (double)i;
                CIND0.makeRGB();
                p = new Pen(Color.FromArgb(CIND0.r, CIND0.g, CIND0.b), 1.0f);
                gr.DrawLine(p, 0, ph - i, pw, ph - i);
            }
            gr.Dispose();
            this.backgroundWorker1.RunWorkerAsync();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.backgroundWorker1.CancelAsync();
            button1.Enabled = true;
            button2.Enabled = false;
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            int k;
            int T1, T2, T3, T4;
            Pen pp;
            Font fnt;
            SolidBrush bb;
            Graphics g = pictureBox1.CreateGraphics();
            ColorIND CIND = new ColorIND();
            CIND.max = Convert.ToDouble(textBox1.Text);
            CIND.min = Convert.ToDouble(textBox2.Text);
            BufferedGraphicsContext currentContext;
            BufferedGraphics myBuffer;
            currentContext = BufferedGraphicsManager.Current;
            myBuffer = currentContext.Allocate(pictureBox1.CreateGraphics(), this.DisplayRectangle);
            UDP.Connect(IPAddress.Parse(IP_ADRS), 11000);//サーモグラフィ側のIPとポート指定
            UDP.Client.SendTimeout = 5000;
            UDP.Client.ReceiveTimeout = 5000;
            UDP.Client.ReceiveBufferSize = 700000;
            if (radioButton1.Checked == true)
            {//640×480ドットの場合の処理
                int i, j;
                Bitmap PICT = new Bitmap(640, 480);
                sdata = Encoding.ASCII.GetBytes("GET6");
                UDP.Client.Send(sdata);

                while (backgroundWorker1.CancellationPending == false)
                {
                    while (true)
                    {
                        k = 2;
                        UDP.Client.Receive(rdata);
                        i = rdata[0] + ((int)rdata[1] << 8);
                        if (i >= 480)
                        {
                            T1 = rdata[2] + ((int)rdata[3] << 8);//thermo 5B（アドレス）
                            T2 = rdata[4] + ((int)rdata[5] << 8);//thermo 5C
                            T3 = rdata[6] + ((int)rdata[7] << 8);//thermo 5D
                            T4 = rdata[8] + ((int)rdata[9] << 8);//thermo 5E
                            break;
                        }
                        for (j = 0; j < 640; j++)
                        {//センサーからの色データはR,G,BでなくB,G,Rになっている
                            int B = (rdata[k] & 0x1F) << 3;
                            int G = (rdata[k] & 0xE0) >> 3;
                            k++;
                            G += ((rdata[k] & 0x07) << 5);
                            int R = rdata[k] & 0xF8;
                            k++;
                            PICT.SetPixel(j, i, Color.FromArgb(B, G, R));
                        }
                    }
                    if (radioButton3.Checked == true)
                    {//ダブルバッファを使って表示（フレームモード）
                        myBuffer.Graphics.DrawImage(PICT, new Point(0, 0));
                        CIND.deg = (double)T3 / 50.0 - (273.15 + TOFF);//5Dの赤外線センサー
                        CIND.makeRGB();
                        pp = new Pen(Color.FromArgb(CIND.r, CIND.g, CIND.b), 2.0f);
                        myBuffer.Graphics.DrawRectangle(pp, 20, 20, 290, 210);
                        CIND.deg = (double)T2 / 50.0 - (273.15 + TOFF);//5C
                        CIND.makeRGB();
                        pp = new Pen(Color.FromArgb(CIND.r, CIND.g, CIND.b), 2.0f);
                        myBuffer.Graphics.DrawRectangle(pp, 330, 20, 290, 210);
                        CIND.deg = (double)T4 / 50.0 - (273.15 + TOFF);//5E
                        CIND.makeRGB();
                        pp = new Pen(Color.FromArgb(CIND.r, CIND.g, CIND.b), 2.0f);
                        myBuffer.Graphics.DrawRectangle(pp, 20, 250, 290, 210);
                        CIND.deg = (double)T1 / 50.0 - (273.15 + TOFF);//5B
                        CIND.makeRGB();
                        pp = new Pen(Color.FromArgb(CIND.r, CIND.g, CIND.b), 2.0f);
                        myBuffer.Graphics.DrawRectangle(pp, 330, 250, 290, 210);
                        myBuffer.Render(pictureBox1.CreateGraphics());
                    }
                    else if (radioButton4.Checked == true)
                    {//タイルモード
                        myBuffer.Graphics.DrawImage(PICT, new Point(0, 0));
                        CIND.deg = (double)T3 / 50.0 - (273.15 + TOFF);//5D
                        CIND.makeRGB();
                        bb = new SolidBrush(Color.FromArgb(100, CIND.r, CIND.g, CIND.b));
                        myBuffer.Graphics.FillRectangle(bb, 30, 30, 270, 190);
                        CIND.deg = (double)T2 / 50.0 - (273.15 + TOFF);//5C
                        CIND.makeRGB();
                        bb = new SolidBrush(Color.FromArgb(100, CIND.r, CIND.g, CIND.b));
                        myBuffer.Graphics.FillRectangle(bb, 340, 30, 270, 190);
                        CIND.deg = (double)T4 / 50.0 - (273.15 + TOFF);//5E
                        CIND.makeRGB();
                        bb = new SolidBrush(Color.FromArgb(100, CIND.r, CIND.g, CIND.b));
                        myBuffer.Graphics.FillRectangle(bb, 30, 260, 270, 190);
                        CIND.deg = (double)T1 / 50.0 - (273.15 + TOFF);//5B
                        CIND.makeRGB();
                        bb = new SolidBrush(Color.FromArgb(100, CIND.r, CIND.g, CIND.b));
                        myBuffer.Graphics.FillRectangle(bb, 340, 260, 270, 190);
                        myBuffer.Render(pictureBox1.CreateGraphics());
                    }
                    else
                    {//映像のみ表示
                        myBuffer.Graphics.DrawImage(PICT, new Point(0, 0));
                        myBuffer.Render(pictureBox1.CreateGraphics());
                    }
                }
            }
            else
            {//320×240ドット（4箇所の温度を文字でも表示）
                int i, j;
                Bitmap PICT = new Bitmap(320, 240);
                sdata = Encoding.ASCII.GetBytes("GET3");
                UDP.Client.Send(sdata);
                while (backgroundWorker1.CancellationPending == false)
                {
                    while (true)
                    {
                        k = 2;
                        UDP.Client.Receive(rdata);
                        i = rdata[0] + ((int)rdata[1] << 8);
                        if (i >= 240)
                        {
                            T1 = rdata[2] + ((int)rdata[3] << 8);
                            T2 = rdata[4] + ((int)rdata[5] << 8);
                            T3 = rdata[6] + ((int)rdata[7] << 8);
                            T4 = rdata[8] + ((int)rdata[9] << 8);
                            break;
                        }
                        for (j = 0; j < 320; j++)
                        {
                            int B = (rdata[k] & 0x1F) << 3;
                            int G = (rdata[k] & 0xE0) >> 3;
                            k++;
                            G += ((rdata[k] & 0x07) << 5);
                            int R = rdata[k] & 0xF8;
                            k++;
                            PICT.SetPixel(j, i, Color.FromArgb(B, G, R));
                        }
                    }
                    if (radioButton3.Checked == true)
                    {
                        myBuffer.Graphics.Clear(Color.Black); 
                        myBuffer.Graphics.DrawImage(PICT, new Point(160, 120));
                        fnt = new Font("Arial", 20);
                        CIND.deg = (double)T3 / 50.0 - (273.15 + TOFF);//5D
                        CIND.makeRGB();
                        pp = new Pen(Color.FromArgb(CIND.r, CIND.g, CIND.b), 1.0f);
                        myBuffer.Graphics.DrawRectangle(pp, 165, 125, 150, 110);
                        myBuffer.Graphics.DrawString(CIND.deg.ToString("###.00" + "℃"), fnt, Brushes.White, new Point(30, 40));
                        CIND.deg = (double)T2 / 50.0 - (273.15 + TOFF);//5C
                        CIND.makeRGB();
                        pp = new Pen(Color.FromArgb(CIND.r, CIND.g, CIND.b), 1.0f);
                        myBuffer.Graphics.DrawRectangle(pp, 325, 125, 150, 110);
                        myBuffer.Graphics.DrawString(CIND.deg.ToString("###.00" + "℃"), fnt, Brushes.White, new Point(510, 40));
                        CIND.deg = (double)T4 / 50.0 - (273.15 + TOFF);//5E
                        CIND.makeRGB();
                        pp = new Pen(Color.FromArgb(CIND.r, CIND.g, CIND.b), 1.0f);
                        myBuffer.Graphics.DrawRectangle(pp, 165, 245, 150, 110);
                        myBuffer.Graphics.DrawString(CIND.deg.ToString("###.00" + "℃"), fnt, Brushes.White, new Point(30, 410));
                        CIND.deg = (double)T1 / 50.0 - (273.15 + TOFF);//5B
                        CIND.makeRGB();
                        pp = new Pen(Color.FromArgb(CIND.r, CIND.g, CIND.b), 1.0f);
                        myBuffer.Graphics.DrawRectangle(pp, 325, 245, 150, 110);
                        myBuffer.Graphics.DrawString(CIND.deg.ToString("###.00" + "℃"), fnt, Brushes.White, new Point(510, 410));
                        myBuffer.Render(pictureBox1.CreateGraphics());
                    }
                    else if (radioButton4.Checked == true)
                    {
                        myBuffer.Graphics.Clear(Color.Black);
                        myBuffer.Graphics.DrawImage(PICT, new Point(160, 120));
                        fnt = new Font("Arial", 20);
                        CIND.deg = (double)T3 / 50.0 - (273.15 + TOFF);//5D
                        CIND.makeRGB();
                        bb = new SolidBrush(Color.FromArgb(100, CIND.r, CIND.g, CIND.b));
                        myBuffer.Graphics.FillRectangle(bb, 175, 135, 135, 95);
                        myBuffer.Graphics.DrawString(CIND.deg.ToString("###.00" + "℃"), fnt, Brushes.White, new Point(30, 40));
                        CIND.deg = (double)T2 / 50.0 - (273.15 + TOFF);//5C
                        CIND.makeRGB();
                        bb = new SolidBrush(Color.FromArgb(100, CIND.r, CIND.g, CIND.b));
                        myBuffer.Graphics.FillRectangle(bb, 330, 135, 135, 95);
                        myBuffer.Graphics.DrawString(CIND.deg.ToString("###.00" + "℃"), fnt, Brushes.White, new Point(510, 40));
                        CIND.deg = (double)T4 / 50.0 - (273.15 + TOFF);//5E
                        CIND.makeRGB();
                        bb = new SolidBrush(Color.FromArgb(100, CIND.r, CIND.g, CIND.b));
                        myBuffer.Graphics.FillRectangle(bb, 175, 250, 135, 95);
                        myBuffer.Graphics.DrawString(CIND.deg.ToString("###.00" + "℃"), fnt, Brushes.White, new Point(30, 410));
                        CIND.deg = (double)T1 / 50.0 - (273.15 + TOFF);//5B
                        CIND.makeRGB();
                        bb = new SolidBrush(Color.FromArgb(100, CIND.r, CIND.g, CIND.b));
                        myBuffer.Graphics.FillRectangle(bb, 330, 250, 135, 95);
                        myBuffer.Graphics.DrawString(CIND.deg.ToString("###.00" + "℃"), fnt, Brushes.White, new Point(510, 410));
                        myBuffer.Render(pictureBox1.CreateGraphics());
                    }
                    else
                    {//映像のみでも温度を表示
                        myBuffer.Graphics.Clear(Color.Black);
                        myBuffer.Graphics.DrawImage(PICT, new Point(160, 120));
                        fnt = new Font("Arial", 20);
                        CIND.deg = (double)T3 / 50.0 - (273.15 + TOFF);//5D
                        myBuffer.Graphics.DrawString(CIND.deg.ToString("###.00" + "℃"), fnt, Brushes.White, new Point(30, 40));
                        CIND.deg = (double)T2 / 50.0 - (273.15 + TOFF);//5C
                        myBuffer.Graphics.DrawString(CIND.deg.ToString("###.00" + "℃"), fnt, Brushes.White, new Point(510, 40));
                        CIND.deg = (double)T4 / 50.0 - (273.15 + TOFF);//5E
                        myBuffer.Graphics.DrawString(CIND.deg.ToString("###.00" + "℃"), fnt, Brushes.White, new Point(30, 410));
                        CIND.deg = (double)T1 / 50.0 - (273.15 + TOFF);//5B
                        myBuffer.Graphics.DrawString(CIND.deg.ToString("###.00" + "℃"), fnt, Brushes.White, new Point(510, 410));
                        myBuffer.Render(pictureBox1.CreateGraphics());
                    }
                }
            }
            myBuffer.Dispose();
            sdata = Encoding.ASCII.GetBytes("END");
            UDP.Client.Send(sdata);
            //パケットロスに備えてENDを２回送信
            sdata = Encoding.ASCII.GetBytes("END");
            UDP.Client.Send(sdata);
            e.Cancel = true;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            UDP.Client.Close();
        }

    }
//******************************カラーインデックス用クラス******************************
    public class ColorIND
    {
        public double max;//インデックスの最大値
        public double min;//インデックスの最小値
        public double deg;//色を決めたい温度
        public int r, g, b;//求めた色（R,G,B）
        public ColorIND()
        {
            max = 100.0;
            min = 0.0;
            deg = 25.0;
            r = 0;
            g = 0;
            b = 0;
        }
        public void makeRGB()
        {
            double d;//最小値からの差
            double s = max - min;//最大値と最小値の範囲
            if (deg > max)
            {
                d = max;
            }
            else if (deg < min)
            {
                d = min;
            }
            else
            {
                d = deg - min;
            }
            double h = d * 6.0 / (double)s;
            double v = h - (double)((int)h);
            switch ((int)h)
            {
                case 0://(0,0,0) - (0,0,255)
                    r = 0;
                    g = 0;
                    b = (int)(v * 255.0);
                    break;
                case 1://(0,0,255) - (0,255,255)
                    r = 0;
                    g = (int)(v * 255.0);
                    b = 255;
                    break;
                case 2://(0,255,255) - (0,255,0)
                    r = 0;
                    g = 255;
                    b = 255 - (int)(v * 255.0);
                    break;
                case 3://(0,255,0) - (255,255,0)
                    r = (int)(v * 255.0);
                    g = 255;
                    b = 0;
                    break;
                case 4://(255,255,0) - (255,0,0)
                    r = 255;
                    g = 255 - (int)(v * 255.0);
                    b = 0;
                    break;
                case 5://(255,0,0) - (255,255,255)
                    r = 255;
                    g = (int)(v * 255.0);
                    b = (int)(v * 255.0);
                    break;
                case 6://(255,0,0) - (255,255,255)
                    r = 255;
                    g = 255;
                    b = 255;
                    break;
                default:
                    r = 0;
                    g = 0;
                    b = 0;
                    break;

            }
        }
    }
}
